{smcl}
{* *! version 0.23 beta  27fev2015}{...}
{findalias asfradohelp}{...}
{vieweralsosee "" "--"}{...}
{vieweralsosee "[R] help" "help help"}{...}
{viewerjumpto "Syntax" "examplehelpfile##syntax"}{...}
{viewerjumpto "Description" "examplehelpfile##description"}{...}
{viewerjumpto "Options" "examplehelpfile##options"}{...}
{viewerjumpto "Compatibility issues" "examplehelpfile##comp"}{...}
{viewerjumpto "Examples" "examplehelpfile##examples"}{...}
{title:Title}

{phang}
{bf:coverage} {hline 2} Generate an excel file summarizing how numeric variables are covered/missing in the dataset or in its subsets

{marker syntax}{...}
{title:Syntax}

{p 8 17 2}
{cmd:coverage}
{varlist}
[{cmd:,} {it:options}]

{synoptset 20 tabbed}{...}
{synopthdr}
{synoptline}
{syntab:Aggregation}
{synopt:{opth by:group(fvvarlist)}}specify the (factor) variable(s) identifying data subsets{p_end}
{synopt:{opth o:ver(varname)}}cut the dataset or subsets along the values taken by {varname}{p_end}

{syntab:Statistics}
{synopt:{opt mi:ssings}}Output excel file will show missing ratios for each variable of {help fvvarlist} per subset{p_end}
{synopt:{opt me:ans}}Output excel file will show the mean of each variable of {help fvvarlist} per subset{p_end}
{synopt:{opth d:ecimals(int)}}Specify the number of digits counting as decimals in the "{it:coverage}" sheet{p_end}
{synoptline}


{marker description}{...}
{title:Description}

{pstd}
{cmd:coverage} generates an excel file and save it in the current directory. Without options specified, the file contains
only one sheet called "{it:coverage}". The option {cmd:bygroup({help fvvarlist})} generates additionally one or several sheets called
"{it: by(...)}" where "..." is any combination of the variables specified in {help fvvarlist}, and possibly one or several sheets
called "{it: twoway(...)}" where "..." is any combination of {it:two} variables specified in {help fvvarlist}.

{pstd}The "{it:coverage}" sheet contains summarized information on the missing values of the variables of {help varlist},
disaggregated by subsets specified in options {cmd:bygroup({help fvvarlist})} and {cmd:over({help varname})}. This sheet contains 
8 to 9 columns:{p_end}
{phang2}Column {it:Variable}: contains each variable specified in {help varlist}. Variables are sorted by increasing values of {it:MissingRatio} and grouped by subsets defined by {it:GroupingVariables} and {it:Over({help varname})}.{p_end}
{phang2}Column {it:VariableLabel}: contains the label associated to this variable{p_end}
{phang2}Column {it:MissingRatio}: contains the percentage of missing observations for this variable. A ratio of 0 means the variable is never missing; a ratio of 1 means it is always missing.{p_end}
{phang2}Column {it:SampleSize}: gives the number of observations for this variable after deleting its missing values. Obtained from computing {it:TotalSampleSize}*(1-{it:MissingRatio}){p_end}
{phang2}Column {it:MissingRatioCumulated}: contains the percentage of missing observations by listwise-deleting missing observations from this variable and all the previous ones in this subset.{p_end}
{phang2}Column {it:SampleSizeCumulated}: gives the number of observations after listwise-deletion of this variable and all the previous ones of this subset. Obtained from computing {it:TotalSampleSize}*(1-{it:MissingRatioCumulated}).
This column is helpful to anticipate the sample size one can expect by estimating a model whose variables belong to {help varlist}. Hence it helps the analyst to proceed the trade-off between correct specification and loss of sample size.{p_end}
{phang2}Column {it:GroupingVariables}: Define the subsets upon which the row refers to. If no option {cmd:bygroup({help fvvarlist})} is specified, this column admits only one value "(No Grouping)", 
meaning the rows refer to the whole dataset.
Otherwise, the coverage statistics are given for each variable of {help fvvarlist}, and each factor combination of them. For example, if {cmd:bygroup(country##year)} is specified,
then the dataset will be collapsed successively by country, by year, and by country*year, and the {it:SampleSize} will 
refer respectively to the number of countries, the number of years, and the number of country-years for which this variable is available.{p_end}
{phang2}Column {it:TotalSampleSize}: gives the total number of observations in the considered data (sub)set.{p_end}
{phang2}Column {it:Over({help varname})} [optional]: indicates for which of the values taken by {help varname} the coverage statistics of {help varlist} by subsets of {help fvvarlist} are given.
This column only appears when option {cmd:over({help varname})} is specified.{p_end}

{pstd}The "{it:by(...)}" sheets only appears if {cmd:bygroup({help fvvarlist})} is specified, where "..." is any of the P combinations of variables "variable'p'" 
given by {help fvvarlist} under the following form: variable1[[#[#]]variable2[[#[#]]variable3[..]]].
For instance, if option {cmd:bygroup(country##year)} is specified, where country and year are variables of the dataset coding for the country and year of the survey,
then three sheets called "{it:by(country)}", "{it:by(year)}" and "{it:by(country year)}" will be generated.
Each of these sheets will display whether variables of {help varlist} are available in a subset determined by each of the combinations of {help fvvarlist}.
The coverage of these variables is disaggregated by the R values taken by {help varname}.
These sheets contain at least 2 columns, and up to P+K+1 columns, where K is the number of variables in {help varlist}:{p_end}
{phang2}Column {it:{help varname}} [optional]: specifies to which of all R values (including missing values) taken by {help varname} the statistics are computed for. Only available if option {cmd:over({help varname})} is specified.{p_end}
{phang2}Columns {it:variable'p'}: all these P columns take the name of the "{it:by(...)}". Each contains all the values (including missing ones) taken by "variable'p'".
Typically, these values could refer to each country if "variable'p'" is a country code variable.{p_end}
{phang2}Columns {it:variable'k'}: all these K columns "variable'k'" refer to variables of {help varlist}. If options {cmd: missings} and {cmd: means} are not specified, these columns will be binary variables.
Their value will be 1 if "variable'k'" is covered in the country determined by the value of "variable'p'" (in the case "variable'p'" refers to a country code variable).
Their value will be 0 if "variable'k'" is not covered in this country.{p_end}

{pstd}The "{it:twoway(...)}" sheets are particularly useful to visually appraise the general structure of a survey, and only appears if {cmd:bygroup({help fvvarlist})} is specified,
for each possible combination of {it:two} variables of {help fvvarlist}. For instance, if option {cmd:bygroup(country##year)} is specified,
then one sheet called "{it:twoway(country year)}" will be generated, in addition to the sheets "{it:by(country)}", "{it:by(year)}" and "{it:by(country year)}".
Each of these sheets will display several matrices indicating for each of the variables of {help varlist} whether it is available in a subset determined by the {it:pair} of variables of "{it:twoway(...)}".
The coverage of these variables is disaggregated by the R values taken by {help varname}.
These sheets contain at least 3 columns, and up to Q+3 columns, where Q is the number of values taken by the 2nd variable given in "{it:twoway(...)}": {p_end}
{phang2}Column {it:{help varname}} [optional]: specifies to which of all R values (including missing values) taken by {help varname} the statistics are computed for. Only available if option {cmd:over({help varname})} is specified.{p_end}
{phang2}Column {it:Variables}: indicates which of the K variables of {help varlist} the statistics are computed for.{p_end}
{phang2}Column {it:variable'p'}: this column takes the name of the first variable considered in the pair given by "{it:twoway(...)}" sheet.
For instance, if {cmd:bygroup(country##year)} is specified, this column is called "country" and its values are all the countries of the dataset.{p_end}
{phang2}Columns {it:value'q'}: all these Q columns refer to the values taken by the second variable considered in the pair given by "{it:twoway(...)}" sheet.
For instance, if {cmd:bygroup(country##year)} is specified, these Q columns will take the name of the Q years of the survey.
If options {cmd: missings} and {cmd: means} are not specified, the values appearing in the matrices will be binary variable.
Their value will be 1 if the variable given at the column {it:Variables} is covered in the group given by the column {it:variable'p'} (e.g. a given country)
and the column {it:value'q'} (e.g. a given year).
Their value will be 0 if this variable is not covered in this pair (e.g. in this country-year).
Importantly, if their value is missing (blank), it means that the pair was not covered at all by any variable whatsoever (e.g. there was no survey in this country-year).{p_end}


{marker options}{...}
{title:Options}

{dlgtab:Aggregation}

{phang}
{opth by:group(fvvarlist)}} Specifies a list of categorical variables that identifies subpopulations for which you want to compute
coverage statistics, allowing factor variables. A typical use for this option when using large datasets is when you want to know
if a variable has been covered in a given country at a given year.

{pmore}Then, categorical variables "country" and "year" could be used to specify the option {cmd:bygroup(country year)}.
The "{it:coverage}" sheet will give as a result the number of countries, and the number of years,
where the variables of {help varlist} are covered. The "{it:by(country)}" and "{it:by(year)}" sheets will give more detailed
information on which of the countries, and on which of the years, the variables are covered.

{pmore}The same variables could be used to specify instead the option {cmd:bygroup(country#year)}. In this case, the "{it:coverage}"
sheet will give as result the number of country-years where the variables are covered; and the "{it:by(country year)}" sheet
will tell for which of the country-years these variables are covered. An additional sheet called "{it:twoway(country year)}" will
also be generated, containing the same information as "{it:by(country year)}", but in a visually more convenient way, also helping
to identify which country-years were surveyed or not.

{pmore}Note that typing {cmd:bygroup(country##year)} is equivalent of typing {cmd:bygroup(country year country#year)}.
Note that {help fvvarlist} will be automatically withdrawn from {help varlist} if the latter contains its base variables
(for instance, if you typed * in {help varlist}).
Also note that specifying several interactions of variables with long variable names may induce a bug due to Excel's
limitations in the sheetname length.

{phang}
{opth o:ver(varname)} Specifies a categorical variable cutting the datasets in different parts: the program will consider each part
separately and will compute for each of them the coverage statistics and the {cmd:bygroup({help fvvarlist})}, then render the results
in a unique excel file. This option is particularly helpful for analytical purpose, in conjunction with option {cmd:missings},
when you suspect that the missing structure of a variable in {help varlist} can be explained in terms of {help varname}.
See examples at the bottom.

{pmore}Note that {help varname} will be automatically withdrawn from {help varlist} if the latter contains it
(for instance, if you typed * in {help varlist}).


{dlgtab:Statistics}

{phang}
{opt mi:ssings} When specified, the sheets "{it:by(...)}" and "{it:twoway(...)}" will no longer contain binary variables indicating whether
a variable is covered (1) or not (0) in a given group, but rather will contain a real value indicating the proportion of missing values of
a given variable for a given group. A value of 1,00 will then indicates that the variable is always missing for a given group.
A value of 0,00 will indicates it is never missing. And a blank value in the "{it:twoway(...)}" sheet still indicates that this group does not exist.

{pmore}This option cannot be used if option {cmd:means} is specified.

{phang}
{opt me:ans} When specified, the sheets "{it:by(...)}" and "{it:twoway(...)}" will no longer contain binary variables indicating whether
a variable is covered (1) or not (0) in a given group, but rather will contain a real value equalling the mean taken by the variable
in a given group. A blank value in the "{it:twoway(...)}" sheet still indicates that this group does not exist.

{pmore}This option cannot be used if option {cmd:missings} is specified.

{phang}
{opth d:ecimals(int)} Specifies the number of digits counting as decimals in the "{it:coverage}" sheet. Default is 3 digits (.001).


{marker comp}{...}
{title:Compatibility issues}

{pstd}
The program is still in beta version. Most bugs are likely to rise from Stata's (and/or Excel) memory limitations. To avoid them, consider reducing the number
of variables in {help varlist}, the number of interactions in {help fvvarlist}, the number of unique values per variable in {help fvvarlist},
the number of unique values for the variable {help varname}, or the length of the variable names in {help fvvarlist}.

{pstd}If you experience any trouble or bugs, please send me an e-mail at the address specified at the beginning of the .ado file.


{marker examples}{...}
{title:Examples}

{pstd}Open NLSY data on young women aged 14/26 years in 1968, and display missing statistics for each variable:{p_end}
{phang2}{cmd:. use "http://www.stata-press.com/data/r13/nlswork.dta",clear}{p_end}
{phang2}{cmd:. coverage *}{p_end}
{phang2}* The excel file orders variables by increasing missing rates. SampleSizeCumulated gives the number of observations remaining after listwise-deletion of missing values on all variables except those below the considered row.{p_end}
{phang2}* For instance, a model using all the variables of the dataset will imply a loss of 52.9% of the sample.
Omitting the "union" variable will allow to recover 0.529-0.233=29.6% of the sample (8,427 observations out of 28,534).{p_end}

{pstd}Check if all variables are available every year:{p_end}
{phang2}{cmd:. coverage *,by(year)}{p_end}
{phang2}* No, they are not: In "coverage" sheet, variable "union" is available in 12 years out of 15{p_end}
{phang2}* The "by(year)" sheet indicates "union" is missing in 1968, 1969, and 1975.{p_end}

{pstd}Check if variables pattern in non-response may be influenced by age:{p_end}
{phang2}{cmd:. coverage *,over(age)}{p_end}
{phang2}* We can sort the "coverage" sheet by "Variable" then by "Over(age)" and visualize changes in MissingRatios with age for each variable.{p_end}
{phang2}* We can see that the younger people have higher non-response rates for "union" variable in comparison to the older people{p_end}
{phang2}* But they have lower non-response rates for "wks_ue" (number of weeks unemployed last year). It might be worthwile to investigate that issue.{p_end}

{pstd}Check the suspicious non-response rates structured by age and year of survey:{p_end}
{phang2}{cmd:. coverage union wks_ue,by(age##year) missings}{p_end}
{phang2}* In the "by(age)" sheet, we retrieve the suspicious gradient of non-response of these two variables with age{p_end}
{phang2}* In the "twoway(age year)" sheet, we can check the general structure of the dataset: the sample is initially constituted of 14-26 years old,
followed for 20 years since 1968.  No new younger/older cohorts seems to be introduced along the series.{p_end}
{phang2}* In this sheet, with conditional formatting, we can color cells by the magnitude of the missing ratios, to better appraise the results{p_end}
{phang2}* The results indicate that the under-response of "union" for the young was partially caused by the fact that this question was not asked in
1968, 1969, and 1975, but this does not explain all the youngs' non-response.{p_end}
{phang2}* Nor does it explain the gradient of non-response for the "wks_ue" variable, which rates were exceptionally high in 1980, 1982, 1985, and 1987.{p_end}

{pstd}Verify how evolved mean values of labor market-related variables:{p_end}
{phang2}{cmd:. coverage union wks_ue wks_work hours ln_wage,by(age##year) means}{p_end}
{phang2}* In the "twoway(age year)" sheet, we observe that the non-response pattern of "union" seems not correlated with underlying changes in the proportions of unionized people.{p_end}
{phang2}* However, unemployment ("wks_ue") was remarkably high for most age categories in the same years where non-response was high (1980, 1982, 1985 and 1987).
We can ask ourselves whether the high non-response rate generated a bias in the estimates, or is the result of exogenous economic shocks.{p_end}
{phang2}* The "by(year)" sheet indicates that the increase of non-response in these 4 years was positively related with an increase of unemployed weeks {it:and}
of worked weeks, while other variables remained essentially unchanged (unionized rate, hours worked per week, and deflated wage), which is contradictory to
intuition and suggests deeper inspection of data and documentation.

{pstd}Display the unemployed non-response for each individual across years:{p_end}
{phang2}{cmd:. coverage wks_ue,by(idcode##year)}{p_end}
{phang2}* In the "twoway(idcode year)" sheet, we can color cells conditionally on the response dummy, then dezoom to the maximum and visually appraise the results by scrolling down the 4711 rows{p_end}
{phang2}* The four years with high peaks of non-response are really due to occasional non-response of individuals actually surveyed, and not of individuals temporarily dropping out of the panel.{p_end}
